#!/usr/bin/python

import remote

minpythonversion = "2.3"

reset = "\033[0m"
green = "\033[92m"
yellow = "\033[93m"
red = "\033[91m"
fat = "\033[1m"

def colour(attribute, s):
	s = attribute + s + reset
	return s

def pythonversion(expected, found):
	expected += ".0.0"
	found += ".0.0"
	(major, minor, rest) = expected.split(".", 2)
	(major2, minor2, rest2) = found.split(".", 2)
	if major2 > major:
		return 1
	if major2 == major and minor2 >= minor:
		return 1
	return 0

def displayresult(url, ret, output, islocal):
	state = ""
	result = ""
	python = ""

	if islocal:
		state = "(local node)"
	else:
		state = " " * 12
		if len(url) > 26 and len(url) < 26 + 12:
			state = " " * (26 + 12 - len(url))

	if output and ret == 0:
		python = output[0].split(" ")[1]
		x = pythonversion(minpythonversion, python)
		if x == 0:
			python = colour(yellow, python + " - expected: " + minpythonversion)
		else:
			python = colour(green, python)
		python = "(Python: " + python + ")"

	if not output:
		result = colour(red, "local error! (see above)")
	elif ret == 0:
		result = colour(green, "ok")
	else:
		result = colour(red, "error!")

	print ":: %34s %s %10s %20s" % (colour(fat, url), state, result, python)

	if output and ret != 0:
		print output[0]

def check(hosts, verbose):
	for url in hosts:
		if not url:
			continue

		r = remote.Remote(url)
		if verbose:
			r.verbose = 1

		ret = r.setup()
		if ret != 0:
			displayresult(url, ret, None, r.islocal())
			continue

		(ret, output) = r.rexecute("python -V")

		displayresult(url, ret, output, r.islocal())

