#!/usr/bin/env python

import socket
import os

def parsescript(script):
	try:
		f = open(script)
		lines = f.readlines()
		f.close()
	except:
		return None

	execlines = []
	tmp = ""
	for line in lines:
		if line[0] != " " and line[0] != "\t" and line[0] != "\n":
			if tmp:
				tmp = tmp.strip()
				execlines.append(tmp)
			tmp = line
		else:
			tmp += line
	tmp = tmp.strip()
	execlines.append(tmp)

	return execlines

def environment(globals):
	env = {}

	interface = [
		"connect", "send", "schedule",
		"channel", "sender", "receiver", "scheduler", "node",
		"Channel", "Sender", "Receiver", "Scheduler", "Node"
	]

	for gn in globals.keys():
		if gn in interface:
			env[gn] = globals[gn]

	return env

def interfacenodes():
	cmd = "LANG=C /sbin/ifconfig"
	cmd += "| grep \"inet addr\""
	cmd += "| cut -d \":\" -f 2"
	cmd += "| cut -d \" \" -f 1"
	(fin, fout) = os.popen2(cmd)

	ret = []
	while 1:
		addr = fout.readline()
		if addr == "":
			break
		addr = addr.strip()
		ret.append(addr)
	return ret

def nodenames():
	tmp = []
	localhostnames = []

	(name, aliases, ips) = socket.gethostbyaddr("127.0.0.1")
	tmp.append(name)
	for alias in aliases:
		tmp.append(alias)
	for ip in ips:
		tmp.append(ip)
	tmp.append(socket.getfqdn())
	tmp.append(socket.gethostname())

	tmp += interfacenodes()

	for host in tmp:
		if not host in localhostnames:
			localhostnames.append(host)
			localhostnames.append(os.getenv("USER") + "@" + host)

	return localhostnames

