# -*- coding: utf-8 -*-

import re
import pickle
import code

reset = "\033[0m"
console = "\033[90m"

def output(s):
	print console + s + reset

def outputcont(s):
	print console + s + reset,

class Inspector:
	def __init__(self):
		self.scheduler = None

	def setscheduler(self, scheduler):
		self.scheduler = scheduler

	def inspect(self):
		output("<inspector: enter>")
		output("<inspector: type /help to get a command overview>")
		if not self.scheduler:
			output("<inspector: warning - no scheduler object found>")

		try:
			self.doinspect()
		except KeyboardInterrupt:
			print
			output("<inspector: leave>")
			return
		raise KeyboardInterrupt

	def doinspect(self):
		cmd_exit = re.compile("/exit")
		cmd_help = re.compile("/help")
		cmd_list = re.compile("/list (\S+)")
		cmd_info = re.compile("/info")
		cmd_save = re.compile("/save (\S+)")
		cmd_load = re.compile("/load (\S+)")
		cmd_inspect = re.compile("/inspect")

		while 1:
			outputcont("inspector#>>")
			try:
				line = raw_input()
			except EOFError:
				print
				continue

			m = cmd_list.match(line)
			if m:
				what = m.group(1)
				if what == "nodes":
					output("LIST NODES")
				elif what == "channels":
					output("LIST CHANNELS")
				else:
					output("Sorry, cannot list " + what)

			m = cmd_info.match(line)
			if m:
				self.scheduler.information()

			m = cmd_save.match(line)
			if m:
				filename = m.group(1)
				pickle.dump(self.scheduler, open(filename, "w"))
				output("<inspector: saved simulation>")

			m = cmd_load.match(line)
			if m:
				filename = m.group(1)
				self.scheduler = pickle.load(open(filename))
				output("<inspector: loaded simulation>")

			m = cmd_inspect.match(line)
			if m:
				locals = {}
				locals["scheduler"] = self.scheduler
				output("<inspector: enter live inspection>")
				code.interact(None, raw_input, locals)
				output("<inspector: leave live inspection>")

			m = cmd_help.match(line)
			if m:
				output("/info - Invoke scheduler information table")
				output("/list nodes|channels - List objects in scheduler")
				output("/save <filename> - Save the simulation status")
				output("/load <filename> - Load the simulation status")
				output("/inspect - Live inspection of all objects")
				output("/exit - Abort the simulation")
				output("Ctrl+C - Leave the inspector, return to the simulation")

			m = cmd_exit.match(line)
			if m:
				return

inspector = Inspector()
