#!/usr/bin/env python

"""
MESSAGE ('estimate', (287, 1), 286, 5) FROM node#101 IN node#89 <Round: (287, 2)>
Coordinator: registered estimate message
Coordinator: 51 out of 100 messages
Coordinator: of which 51 are estimates
Coordinator: majority of messages reached!
Coordinator: majority sent estimate; send newestimate
Highest stamp was 286
Therefore use vote 5
"""

"""
MESSAGE ('ack', (292, 3)) FROM node#51 IN node#94 <Round: (292, 4)>
Coordinator: got ack
Coordinator: 51 out of 100 messages
Coordinator: of which 51 are acks
Coordinator: majority of messages reached!
Coordinator: majority sent ack; send decide
Decide was 5
"""

import re

# ack or estimate
wanted = "ack"
# 1-...
wantedmacroround = 1
# number of participants
macroroundsize = 100

r_msg = re.compile("MESSAGE \('(\S+)', \(\d+, \d+\)(?:, \d+, \d+)?\) FROM \S+ IN (\S+) <Round: \((\d+), \d+\)>")
r_est = re.compile("Coordinator: registered estimate message")
r_ack = re.compile("Coordinator: got ack")
r_reg = None
r_all = re.compile("Coordinator: (\d+) out of (\d+) messages")
r_got = re.compile("Coordinator: of which (\d+) are (\S+)")
r_dis = re.compile("DISCARD since step is done already")
r_par = re.compile("Participant: wanted newestimate, got something else")
r_ord = re.compile("Ordinary Node: wanted decide, got something else")

STATE_NIL = 0
STATE_MSG = 1
STATE_REG = 2
STATE_ALL = 3
STATE_GOT = 4

state = STATE_NIL

messages = {}
node = None
round = 0
macrorounds = {}

if wanted == "ack":
	r_reg = r_ack
elif wanted == "estimate":
	r_reg = r_est
else:
	print "wanted error"

print "scanning..."
#f = open("100.noqueue-tee.log")
#f = open("100.ps-tee.20sec+5.log")
f = open("/tmp/100.ps-tee.unreliable.log")
while 1:
	line = f.readline()
	if line == "":
		break
	line = line.strip()
	if state == STATE_NIL:
		m_msg = r_msg.match(line)
		if m_msg:
			msg = m_msg.group(1)
			node = m_msg.group(2)
			#print ":::", line
			# node#9
			if len(node) == 6:
				node = node[:5] + "0" + node[-1:]
			round = int(m_msg.group(3))
			if msg == wanted:
				state = STATE_MSG
	elif state == STATE_MSG:
		m_reg = r_reg.match(line)
		m_dis = r_dis.match(line)
		m_par = r_par.match(line)
		m_ord = r_ord.match(line)
		if m_reg:
			state = STATE_REG
		elif m_dis:
			state = STATE_NIL
		elif m_par:
			state = STATE_NIL
		elif m_ord:
			state = STATE_NIL
		else:
			print "state error (reg)"
			print line
			state = STATE_NIL
	elif state == STATE_REG:
		m_all = r_all.match(line)
		if m_all:
			state = STATE_ALL
		else:
			print "state error (all)"
			state = STATE_NIL
	elif state == STATE_ALL:
		m_got = r_got.match(line)
		if m_got:
			state = STATE_GOT
			num = int(m_got.group(1))
			macroround = round / macroroundsize + 1
			if not messages.has_key(node):
				if macroround <= wantedmacroround:
					messages[node] = num
			else:
				oldnum = messages[node]
				if num > oldnum:
					if macroround == wantedmacroround:
						messages[node] = num
				else:
					if num == 1:
						macrorounds[node] = macroround
						if macroround <= wantedmacroround:
							messages[node] = 0
		else:
			print "state error (got)"
			state = STATE_NIL
	elif state == STATE_GOT:
		state = STATE_NIL

f.close()
print "done"

keys = messages.keys()
keys.sort()
for node in keys:
	print node, ":", messages[node],
	if macrorounds.has_key(node):
		print "(", macrorounds[node], ")",
	print

