#!/usr/bin/env python

import pygame
import sys
import re
import math

def display(data):
	pygame.init()
	pygame.display.set_caption("Consensus Rounds")

	screen = pygame.display.set_mode((800, 600), pygame.DOUBLEBUF)

	background = pygame.Surface((screen.get_width(), screen.get_height()))
	background.fill((0, 0, 100))
	screen.blit(background, (0, 0))

	font = pygame.font.SysFont("Vera Sans", 10)

	xc = screen.get_width() / 2
	yc = screen.get_height() / 2

	for node in data:
		num = data[node]
		(n, id) = node.split("#")
		id = int(id)
		#print "node", id, "=", num

		xid = 2 * math.pi * (id - 2) / 100
		#print "xid", xid
		x = int(xc + 5 * math.sin(xid) * num)
		y = int(yc + 5 * math.cos(xid) * num)
		xf = int(xc + 5 * math.sin(xid) * (num + 3))
		yf = int(yc + 5 * math.cos(xid) * (num + 3))
		#print "x/y", x, y, "c:", xc, yc

		#pygame.draw.aaline(screen, (250, 250, 170), (xc, yc), (x, y))
		pygame.draw.line(screen, (250, 250, 250), (xc, yc), (x, y))

		f = font.render(str(id), 1, (255, 220, 0))
		screen.blit(f, (xf, yf))

	while 1:
		event = pygame.event.wait()
		if event.type == pygame.KEYDOWN:
			key = event.key
			if key == pygame.K_ESCAPE or pygame.event.peek(pygame.QUIT):
				break

		pygame.display.flip()

def parsedata(roundlog):
	try:
		f = file(roundlog)
		lines = f.readlines()
		f.close()
	except:
		return None

	data = {}
	for line in lines:
		line = line.strip()
		args = line.split(" : ")
		if len(args) == 2:
			node = args[0]
			tmp = args[1].split(" (")
			num = tmp[0]
			data[node] = int(num)

	return data

if __name__ == "__main__":
	if len(sys.argv) != 2:
		print "Error: no roundlog file specified"
		sys.exit(1)
	roundlog = sys.argv[1]

	data = parsedata(roundlog)
	if not data:
		print "Error: opening roundlog file " + roundlog + " failed"
		sys.exit(1)

	display(data)

